package curve;

/**
 *
 * @author gshute
 */
public class ArrowheadStyle {

  public enum Type {
    NONE,
    OPEN,
    SOLID
  }

  private ArrowheadStyle parent;
  private Double length;
  private Double angle;
  private Type type;

  private void initialize() {
    length = null;
    angle = null;
    type = null;
  }

  public ArrowheadStyle(double l, double a, Type t) {
    parent = null;
    length = l;
    angle = a;
    type = t;
  }

  public ArrowheadStyle(ArrowheadStyle par) {
    parent = par;
    initialize();
  }

  public void inherit() {
    initialize();
  }

  public double getLength() {
    if (length != null) {
      return length;
    }
    return parent.getLength();
  }

  public void setLength(double l) {
    length = l;
  }

  public void unsetLength() {
    length = null;
  }

  public double getAngle() {
    if (angle != null) {
      return angle;
    }
    return parent.getAngle();
  }

  public void setAngle(double a) {
    angle = a;
  }

  public void unsetAngle() {
    angle = null;
  }

  public Type getType() {
    if (type != null) {
      return type;
    }
    return parent.getType();
  }

  public void setType(Type t) {
    type = t;
  }

  public void unsetType() {
    type = null;
  }

}
