package curve;

import java.awt.Shape;
import java.awt.geom.Point2D;

/**
 *  FIXME - add comment.
 *
 *  FIXME - we need to rethink this interface and its implementations.
 *  A curve can have multiple parameterizations.
 *  For example, an elliptical arc may be part of the boundary of a
 *  diagram node or it may be the path for a diagram connector.
 *  We want all diagram boundary arcs to be parameterized by central
 *  angle measured in radians.
 *  We may want simpler parameterizations for diagram connectors.
 *  Also, we may want to have parameterization by x or y coordinate for
 *  rectilinear connections.
 *  That may depend on how we handle node embellishments.
 *
 *  In the future, the getShape() method could have an extra Object
 *  parameter.
 *  A static table could be maintained by subclasses containing a
 *  different shape object for each provided parameter object.
 *  This would reduce the amount of object creation in a program.
 */
public interface Curve {

  /**
   *  c.getShape(t1, t2) returns the shape for the part of c with
   *  parameter values between t1 and t2.
   * @param t1 
   * @param t2 
   * @return 
   */
  public Shape getShape(double t1, double t2);

  /**
   *  c.getX(t) returns the x-coordinate on c for parameter t.
   * @param t 
   * @return 
   */
  public double getX(double t);

  /**
   *  c.getY(t) returns the y-coordinate on c for parameter t.
   * @param t 
   * @return 
   */
  public double getY(double t);

  /**
   *  c.getDX(t) returns the x-coordinate derivative on c for
   *  parameter t.
   * @param t 
   * @return 
   */
  public double getDX(double t);

  /**
   *  c.getDY(t) returns the y-coordinate derivative on c for
   *  parameter t.
   * @param t 
   * @return 
   */
  public double getDY(double t);

  public void setCenter(Point2D center);

}  // public interface Curve

