package curve;

/**
 *
 * @author gshute
 */
public class Intersection {

  Segment segment1;
  Segment segment2;
  IntersectionFinder intersectionFinder;
  private double parameter1;
  private double parameter2;

  public Intersection(Segment s1, Segment s2) {
    segment1 = s1;
    segment2 = s2;
    intersectionFinder = IntersectionFinder.createIntersectionFinder();
  }

  public double getParameter1() {
    return parameter1;
  }

  public double getParameter2() {
    return parameter2;
  }

  public boolean exists() {
    Curve c1 = segment1.getCurve();
    double t1 = (segment1.getT0() + segment1.getT1())/2.0;
    Curve c2 = segment2.getCurve();
    double t2 = (segment2.getT0() + segment2.getT1())/2.0;
    boolean doesExist = intersectionFinder.findIntersection(c1, t1, c2, t2);
    parameter1 = intersectionFinder.getParameter1();
    parameter2 = intersectionFinder.getParameter2();
    return doesExist;
  }

}
