package display;

import java.awt.geom.Point2D;

/**
 * DOCME
 */
public class EllipticalMover
implements Mover {

  private double height;
  private int code;

  public EllipticalMover(double height) {
    this.height = height;
    code = new Double(height).hashCode();
  }

  public Point2D getDelta(double time, int dx, int dy) {
    if (dx == 0 && dy == 0) {
      return new Point2D.Double();
    }
    // FIXME - the current implementation only works if dy = 0.
    // It needs to be generalized.
    assert(dy == 0);
    double deltaY = height;
    double theta = time * Math.PI;
    if (dx < 0) {
      deltaY = -deltaY;
    }
    double x = (1.0 - Math.cos(theta)) * dx / 2.0;
    double y = Math.sin(theta) * deltaY;
    return new Point2D.Double(x, y);
  }
  
  @Override
  public boolean equals(Object obj) {
    if (!(obj instanceof EllipticalMover)) {
      return false;
    }
    EllipticalMover interpolater = (EllipticalMover)obj;
    return interpolater.height == height;
  }

  @Override
  public int hashCode() {
    return code;
  }

}
