package display;

import java.awt.Dimension;
import javax.swing.BorderFactory;
import javax.swing.JComponent;
import javax.swing.JScrollPane;
import javax.swing.JTextPane;
import javax.swing.SwingUtilities;
import javax.swing.text.BadLocationException;
import javax.swing.text.Document;
import javax.swing.text.Position;

/**
 *
 */
public class Log {

  private JTextPane textPane;
  private Document document;

  public Log() {
    textPane = new JTextPane();
    textPane.setEditable(false);
    textPane.setPreferredSize(new Dimension(100, 200));
    document = textPane.getDocument();
  }

  public JComponent getVisual() {
    JScrollPane scrollPane = new JScrollPane(textPane);
    scrollPane.setBorder(BorderFactory.createTitledBorder("Log"));
    return scrollPane;
  }

  public void clearText() {
    SwingUtilities.invokeLater(new Runnable() {

      public void run() {
        textPane.setText("");
      }

    });
  }

  public void addText(final String text) {
    SwingUtilities.invokeLater(new Runnable() {

      public void run() {
        Position end = document.getEndPosition();
        try {
          document.insertString(end.getOffset() - 1, text + "\n", null);
          textPane.setCaretPosition(textPane.getText().length());
        } catch (BadLocationException exception) {
          System.out.println(exception.getMessage());
        }
      }

    });
  }

}
