package display;

/**
 * An Operation<T> is an operation that can be performed on models of type T.
 * In addition to the operate() method, an operation may define methods for
 * setting operation parameters before the operation is performed and methods
 * for obtaining results after it is performed.
 * Operations should also override the toString() method to provide a name that
 * is used in menus.
 */
public interface Operation<T extends Model> {

  public void operate(T model);

}
