package display;

import javax.swing.JComponent;

/**
 * DOCME
 */
public class PaintContext {

  private Grid grid;
  private Canvas canvas;
  private double time;
  private boolean showChanges;

  public PaintContext(Grid grid) {
    this.grid = grid;
    canvas = new Canvas(this);
  }

  public JComponent getCanvas() {
    return canvas;
  }

  public Grid getGrid() {
    return grid;
  }

  public double getTime() {
    return time;
  }

  public void addVisual(Visual visual) {
    canvas.addVisual(visual);
  }

  public void removeVisual(Visual visual) {
    canvas.removeVisual(visual);
  }

  public void show() {
    canvas.commitChanges();
    canvas.repaint();
  }

  public void clear() {
    canvas.clear();
  }

  public void setShowChanges(boolean showChanges) {
    this.showChanges = showChanges;
  }

  public void showChanges() {
    if (!showChanges) {
      return;
    }
    double showTime = 1.0;
    int sleepTime = 20;
    int stepCount = (int)(showTime*1000/sleepTime);
    double timeIncrement = sleepTime*0.001;
    for (int t = 0; t < stepCount; t++) {
      canvas.setTime(t*timeIncrement);
      canvas.repaint();
      try {
        Thread.sleep(sleepTime);
      } catch (InterruptedException ex) {
        break;
      }
    }
    canvas.commitChanges();
    time = 1.0;
  }

  public String getVisualsList() {
    return canvas.getVisualsList();
  }

}
