package display;

/**
 * DOCME
 */
public class PositionChange {

  private int dx;
  private int dy;
  private Mover interpolater;
  private int interpolaterCode;

  public PositionChange() {
    this(null);
  }

  public PositionChange(Mover interpolater) {
    dx = 0;
    dy = 0;
    this.interpolater = interpolater;
    if (interpolater == null) {
      interpolater = new TrivialInterpolater();
    }
    interpolaterCode = interpolater.hashCode();
  }

  public boolean equals(Object obj) {
    if (!(obj instanceof PositionChange)) {
      return false;
    }
    PositionChange pc1 = (PositionChange)obj;
    if (pc1.dx != dx || pc1.dy != dy) {
      return false;
    }
    if (dx == 0 && dy == 0) {
      return true;
    }
    return pc1.interpolater.equals(interpolater);
  }

  public int hashCode() {
    return (dx*233)^(dy*377)^interpolaterCode;
  }

  public int getDX() {
    return dx;
  }

  public void setDX(int dx) {
    this.dx = dx;
  }

  public int getDY() {
    return dy;
  }

  public void setDY(int dy) {
    this.dy = dy;
  }

  public Mover getInterpolater() {
    return interpolater;
  }

}
