package display;

import java.awt.Graphics2D;
import java.awt.geom.AffineTransform;
import java.awt.geom.Point2D;
import java.awt.image.BufferedImage;
import java.util.ArrayList;
import java.util.List;

/**
 * DOCME
 */
public abstract class Sprite {

  private Grid grid;
  private PaintContext context;
  private List<PrimaryVisual> visuals;
  private BufferedImage image;
  private AffineTransform transform;
  private int x0;
  private int y0;
  private int width;
  private int height;

  private void computeBounds() {
    for (PrimaryVisual visual : visuals) {
      // FIXME - examine bounds of visual and adjust x0, y0, width, and
      // height accordingly.
    }
  }

  private BufferedImage createImage() {
    computeBounds();
    if (image == null) {
      image = grid.getBufferedImage(width, height);
    }
    return image;
  }

  private void drawImage() {
    // FIXME - need to do a transformation on g so that a point at the upper
    // right corner of the bounding box paints at the origin in g.
    Graphics2D g = createImage().createGraphics();
    for (PrimaryVisual visual : visuals) {
      visual.paintOn(g, grid, 0);
    }
    g.dispose();
  }

  private Point2D getPosition(double time) {
    // FIXME - add code.
    // Should be able to get this from the first interpolater.
    return null;
  }

  public Sprite(Grid grid) {
    visuals = new ArrayList<PrimaryVisual>();
    transform = new AffineTransform();
  }

  public void addVisual(PrimaryVisual visual) {
    visuals.add(visual);
  }

  public void clear() {
    visuals.clear();
  }

  public void refreshImage() {
    image = null;
  }

  /**
   * sp.drawOn(g, t) draws sp on g.
   * The parameter t is passed to interpolators associated with movable visuals.
   * @param g
   */
  public void drawOn(PaintContext context, Graphics2D graphics) {
    Point2D p = getPosition(context.getTime());
    transform.setToTranslation(p.getX(), p.getY());
    graphics.drawRenderedImage(createImage(), transform);
  }

}
