package display;

import java.awt.Color;
import java.awt.Font;

/**
 *
 * @author gshute
 */
public class TextStyle {

  private TextStyle parent;
  private Font font;
  private Color color;
  private Color selectedColor;

  private void initialize() {
    font = null;
    color = null;
    selectedColor = null;
  }

  public TextStyle(Font f, Color c) {
    parent = null;
    font = f;
    color = c;
    selectedColor = c;
  }

  public TextStyle(TextStyle par) {
    parent = par;
    initialize();
  }

  public void inherit() {
    initialize();
  }

  public Font getFont() {
    if (font != null) {
      return font;
    }
    return parent.getFont();
  }

  public void setFont(Font f) {
    font = f;
  }

  public void unsetFont() {
    font = null;
  }

  public Color getColor() {
    if (color != null) {
      return color;
    }
    return parent.getColor();
  }

  public void setColor(Color c) {
    color = c;
  }

  public void unsetColor() {
    color = null;
  }

  public Color getSelectedColor() {
    if (selectedColor != null) {
      return selectedColor;
    }
    return parent.getSelectedColor();
  }

  public void setSelectedColor(Color c) {
    selectedColor = c;
  }

  public void unsetSelectedColor() {
    selectedColor = null;
  }

}
