package graph;

/**
 * A Dispenser is a container for objects.
 * New objects can be added with the add() method.
 * A dispenser selects one of its objects as the accessible object.
 * Each implementation determines its own policy for selecting the accessible
 * object.
 * This object is removed and returned by the remove() method.
 */
public interface Dispenser {

  public void add(Object obj);

  public boolean isEmpty();

  public Object remove();

}
