package graph;

import java.awt.Color;

/**
 * DOCME
 */
public enum EdgeState {

  start(Color.gray) {
    @Override
    public EdgeState enqueue() {
      return enqueued;
    }
    @Override
    public EdgeState visit() {
      throw new IllegalStateException("Must enter dispenser first");
    }
    @Override
    public EdgeState discard() {
      throw new IllegalStateException("Must enter dispenser first");
    }
  },
  enqueued(Color.red) {
    @Override
    public EdgeState visit() {
      return visited;
    }
    @Override
    public EdgeState discard() {
      return discarded;
    }
  },
  visited(Color.blue),
  discarded(Color.orange);

  private Color color;

  private EdgeState(Color color) {
    this.color = color;
  }

  public Color getColor() {
    return color;
  }

  public EdgeState enqueue() {
    return null;
  }

  public EdgeState visit() {
    return null;
  }

  public EdgeState discard() {
    return null;
  }

}
