package graph;

import display.ArcVisual;
import display.Grid;
import display.PositionChange;
import display.Visual;
import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics2D;

/**
 *
 */
public class UndirectedArcVisual
        implements Visual {

  private EdgeState edgeState;
  private ArcVisual forwardEdge;
  private ArcVisual backwardEdge;
  private ArcVisual activeEdge;

  public double getMinX() {
    return activeEdge.getMinX();
  }

  public double getMinY() {
    return activeEdge.getMinY();
  }

  public double getMaxX() {
    return activeEdge.getMaxX();
  }

  public double getMaxY() {
    return activeEdge.getMaxY();
  }

  public void setColor(Color newColor) {
    activeEdge.setColor(newColor);
  }

  public int getZ() {
    return activeEdge.getZ();
  }

  public void setZ(int newZ) {
    forwardEdge.setZ(newZ);
    backwardEdge.setZ(newZ);
  }

  public BasicStroke getStroke() {
    return activeEdge.getStroke();
  }

  public void setStroke(BasicStroke stroke) {
    forwardEdge.setStroke(stroke);
    backwardEdge.setStroke(stroke);
  }

  public void setStrokeWidth(double width) {
    forwardEdge.setStrokeWidth(width);
    backwardEdge.setStrokeWidth(width);
  }

  public void commitChanges() {
    activeEdge.commitChanges();
  }

  public void paintOn(Graphics2D graphics, Grid grid, double time) {
    activeEdge.paintOn(graphics, grid, time);
  }

  public PositionChange getPositionChange() {
    return activeEdge.getPositionChange();
  }

  public boolean isSpritable() {
    return activeEdge.isSpritable();
  }

}
