package graphsearch;

import graph.Dispenser;
import java.util.ArrayDeque;

/**
 * A FIFODispenser is a dispenser with a first-in-first-out ordering.
 * Its accessible object is the last one that was added.
 * This kind of dispenser is often called a queue.
 */
public class FIFODispenser
        implements Dispenser {

  private ArrayDeque<Object> container;

  // FIXME - add code to implement the graph.Dispenser interface.
  // Don't forget a constructor.

  public FIFODispenser() {
    container = new ArrayDeque<Object>();
  }

  public void add(Object obj) {
    container.add(obj);
  }

  public boolean isEmpty() {
    return container.isEmpty();
  }

  public Object remove() {
    return container.remove();
  }

}
