package graphsearch;

import graph.Dispenser;
import java.util.Stack;

/**
 * A LIFODispenser is a dispenser with a last-in-first-out ordering.
 * Its accessible object is the last one that was added.
 * This kind of dispenser is often called a stack.
 */
public class LIFODispenser
implements Dispenser {

  private Stack<Object> container;

  // FIXME - add code to implement the graph.Dispenser interface.
  // Don't forget a constructor.

  public LIFODispenser() {
    container = new Stack<Object>();
  }

  public void add(Object obj) {
    container.add(obj);
  }

  public boolean isEmpty() {
    return container.isEmpty();
  }

  public Object remove() {
    return container.pop();
  }

}
