package graphsearch;

import display.Log;
import display.OperationController;
import graph.Graph;
import graph.PrioritizingGraphVisitor;
import java.util.HashMap;
import java.util.Map;

/**
 * DOCME
 */
public class SSSPVisitor
        extends PrioritizingGraphVisitor {

  public class VertexData {

    private Object viaEdge;
    private double distance;

    public VertexData() {
      viaEdge = null;
      distance = 0;
    }

    public VertexData(Object viaEdge) {
      this.viaEdge = viaEdge;
      distance = getEdgePriority(viaEdge);
    }

    public double getDistance() {
      return distance;
    }

    public Object getViaEdge() {
      return viaEdge;
    }

    public String toString() {
      return "distance " + distance + " via " + viaEdge;
    }

  }

  private Graph graph;
  private Map<Object, VertexData> vertexDataMap;

  /**
   * ssspv.getEdgePriority(edge) returns the priority assigned by mstv to edge.
   * @param edge an edge
   * @return its priority
   */
  public double getEdgePriority(Object edge) {
    // FIXME - add code.
  }

  public SSSPVisitor() {
    //FIXME - add initialization code.
  }

  /**
   * ssspv.visitEdge(edge) informs ssspv that edge has been visited.
   * @param edge
   */
  @Override
  public void visitEdge(Object edge) {
    // FIXME - add code to record the visitation.
    // Change the logged text to describe the data that was recorded.
    Log log = OperationController.createOperationController().getLog();
    log.addText("Text to be logged");
  }

  /**
   * mstv.isVisited(vertex) returns true if vertex has been visited.
   * @param vertex
   * @return
   */
  public boolean isVisited(Object vertex) {
    // FIXME - add code.
  }

  /**
   * ssspv.startSearch(graph, startVertex) is invoked at the beginning of a
   * search to inform ssspv about the graph being searched and the start vertex
   * for the search.
   * @param graph the graph being searched
   * @param startVertex the start vertex for the search
   */
  public void startSearch(Graph graph, Object startVertex) {
    // FIXME - add code.
    // Among other things, viaMap should be cleared to ensure that more than one
    // search can be performed.
  }

  @Override
  public String toString() {
    return "SSSP";
  }

  /**
   * ssspv.getViaMap() is called after a search to retrieve the map of via edges
   * for the search.
   * The via edge for a vertex is the edge that led to the vertex during the
   * search.
   * @return the map of via edges
   */
  public Map<Object, VertexData> getVertexDataMap() {
    return vertexDataMap;
  }

}
