package painter;

import curve.Curve;
import curve.EllipticalCurve;
import java.awt.geom.Ellipse2D;

/**
 * DOCME
 */
public class EllipsePainter
extends ShapePainter {

  private EllipticalCurve boundary;

  public EllipsePainter(double width, double height) {
    this(width, height, 1.0);
  }

  public EllipsePainter(double width, double height, double strokeWidth) {
    super(new Ellipse2D.Double(-width / 2, -height / 2, width, height),
            strokeWidth);
  }

  @Override
  public Curve getBoundary() {
    double boundaryWidth = getWidth() + getStroke().getLineWidth();
    double boundaryHeight = getHeight() + getStroke().getLineWidth();
    return new EllipticalCurve(boundaryWidth, boundaryHeight);
  }

}
