package painter;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.geom.Point2D;
import java.awt.geom.Rectangle2D;
import javax.swing.JFrame;
import javax.swing.JPanel;

/**
 * DOCME
 */
public class TextPainterTest
        extends JPanel {

  public TextPainterTest() {
    setPreferredSize(new Dimension(500, 200));
  }

  @Override
  public void paintComponent(Graphics g) {
    Graphics2D gg = (Graphics2D) g;
    int x = getWidth() / 2;
    int y = getHeight() / 2;
    Point2D paintPoint = new Point2D.Double(x, y);
    Point2D cornerPoint = new Point2D.Double(x + 1, y + 1);
    Rectangle2D dot = new Rectangle2D.Double();
    dot.setFrameFromCenter(paintPoint, cornerPoint);
    gg.setColor(Color.red);
    gg.fill(dot);
    TextPainter textPainter = new TextPainter("JgqM", 96);
    // Add 1 to height to avoid overlap between text and rectangle.
    double width = textPainter.getWidth();
    double height = textPainter.getHeight();
    RectanglePainter rectanglePainter = new RectanglePainter(width, height);
    gg.setColor(Color.orange);
    rectanglePainter.drawOn(gg, x, y);
    gg.setColor(Color.black);
    textPainter.drawOn(gg, x, y);
  }

  public static void main(String[] args) {
    JFrame frame = new JFrame();
    frame.setLayout(new BorderLayout());
    frame.add(new TextPainterTest(), BorderLayout.CENTER);
    frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    frame.setLocation(100, 100);
    frame.pack();
    frame.setVisible(true);
  }

}
